diff --git a/contrib/ntp/Makefile.am b/contrib/ntp/Makefile.am
index 72c35cb0e45d..2d5e6183261f 100644
--- a/contrib/ntp/Makefile.am
+++ b/contrib/ntp/Makefile.am
@@ -66,7 +66,7 @@ DISTCLEANFILES = .gcc-warning
 BUILT_SOURCES =				\
 	.gcc-warning			\
 	libtool				\
-	html/.datecheck			\
+	$(srcdir)/html/.datecheck	\
 	$(srcdir)/COPYRIGHT		\
 	$(srcdir)/.checkChangeLog	\
 	$(NULL)
@@ -83,7 +83,7 @@ BUILT_SOURCES =				\
 	@sleep 1
 	@touch $@
 
-html/.datecheck: FRC.html
+$(srcdir)/html/.datecheck: $(srcdir)/html/*.html
 	cd $(srcdir)/html && \
 	../scripts/build/checkHtmlFileDates
 
@@ -128,7 +128,7 @@ uninstall-local:
 CommitLog: FRC.CommitLog
 	cd $(srcdir)					\
 	&& $(PATH_TEST) -e CommitLog			\
-		-a SCCS/s.ChangeSet -ot CommitLog	\
+		-a .bk/SCCS/ChangeSet,s -ot CommitLog	\
 	|| scripts/build/genCommitLog
 
 # HMS: The following seems to be a work-in-progress...
diff --git a/contrib/ntp/check-libntp.mf b/contrib/ntp/check-libntp.mf
index 07c855b4be78..86fcca45b0e3 100644
--- a/contrib/ntp/check-libntp.mf
+++ b/contrib/ntp/check-libntp.mf
@@ -3,12 +3,12 @@
 ## sntp/check-libntp.mf
 ## The above file has a version of this for the sntp tree.
 
-BUILT_SOURCES	+= check-libntp
-CLEANFILES	+= check-libntp
+.PHONY: check-libntp
 
-check-libntp: $(top_builddir)/libntp/libntp.a
-	@: avoid default SCCS get by some make implementations
+if LIBNTP_SUBMAKES
+BUILT_SOURCES	+= check-libntp
 
-$(top_builddir)/libntp/libntp.a:
+check-libntp:
 	cd $(top_builddir)/libntp && $(MAKE) $(AM_MAKEFLAGS) libntp.a
 
+endif
diff --git a/contrib/ntp/check-libntpd.mf b/contrib/ntp/check-libntpd.mf
index 46304dd5f236..45133ad52c1c 100644
--- a/contrib/ntp/check-libntpd.mf
+++ b/contrib/ntp/check-libntpd.mf
@@ -4,16 +4,7 @@
 
 BUILT_SOURCES	+= check-libntpd
 
-# CLEANFILES addition below won't be needed after a while.
-# Leave it in for now for folks tracking the source repo
-# who have the file from a former version of the rule.
-# DLH Jan 2023
-
-CLEANFILES	+= check-libntpd
-
-check-libntpd: $(top_builddir)/ntpd/libntpd.a
-	 @: avoid default SCCS get by some make implementations
-
-$(top_builddir)/ntpd/libntpd.a:
+.PHONY: check-libntpd
+check-libntpd:
 	cd $(top_builddir)/ntpd && $(MAKE) $(AM_MAKEFLAGS) libntpd.a
 
diff --git a/contrib/ntp/check-libunity.mf b/contrib/ntp/check-libunity.mf
index 4e052058c0c3..830c72c1a421 100644
--- a/contrib/ntp/check-libunity.mf
+++ b/contrib/ntp/check-libunity.mf
@@ -4,10 +4,10 @@
 ## The above file has a version of this for the sntp tree.
 
 BUILT_SOURCES	+= check-libunity
+CLEANFILES	+= check-libunity
 
 check-libunity: $(top_builddir)/sntp/unity/libunity.a
-	 @: avoid default SCCS get by some make implementations
+	@echo stamp > $@
 
 $(top_builddir)/sntp/unity/libunity.a:
 	cd $(top_builddir)/sntp/unity && $(MAKE) $(AM_MAKEFLAGS) libunity.a
-
diff --git a/contrib/ntp/check-scm-rev.mf b/contrib/ntp/check-scm-rev.mf
index e2abbf0e452c..7c0d1be2892f 100644
--- a/contrib/ntp/check-scm-rev.mf
+++ b/contrib/ntp/check-scm-rev.mf
@@ -1,8 +1,6 @@
 $(top_srcdir)/sntp/scm-rev: FRC.scm-rev
 	$(AM_V_GEN)cd $(top_builddir)/sntp && $(MAKE) $(AM_MAKEFLAGS) check-scm-rev
 
+.PHONY: FRC.scm-rev
 FRC.scm-rev:
-	@: FRC.scm-rev "force" depends on nothing and is not a file, so is	\
-	   always out-of-date causing targets which depend on it to also		\
-	   be outdated so their rules to fire each time they are built.
-
+	@: FRC.scm-rev is always out of date, triggering the check every make invocation.
diff --git a/contrib/ntp/config.h.in b/contrib/ntp/config.h.in
index c00eba442298..bfaabf02e183 100644
--- a/contrib/ntp/config.h.in
+++ b/contrib/ntp/config.h.in
@@ -496,9 +496,6 @@
 /* Define to 1 if the system has the type `int32'. */
 #undef HAVE_INT32
 
-/* int32 type in DNS headers, not others. */
-#undef HAVE_INT32_ONLY_WITH_DNS
-
 /* Define to 1 if the system has the type `int32_t'. */
 #undef HAVE_INT32_T
 
@@ -691,9 +688,6 @@
 /* Define to 1 if you have the <openssl/cmac.h> header file. */
 #undef HAVE_OPENSSL_CMAC_H
 
-/* Define to 1 if you have the <openssl/hmac.h> header file. */
-#undef HAVE_OPENSSL_HMAC_H
-
 /* Define to 1 if the system has the type `pid_t'. */
 #undef HAVE_PID_T
 
@@ -970,7 +964,7 @@
 /* Define to 1 if you have the <sysexits.h> header file. */
 #undef HAVE_SYSEXITS_H
 
-/* */
+/* syslog.h provides facilitynames */
 #undef HAVE_SYSLOG_FACILITYNAMES
 
 /* Define to 1 if you have the <sys/audioio.h> header file. */
@@ -1035,6 +1029,9 @@
 /* Define to 1 if you have the <sys/prctl.h> header file. */
 #undef HAVE_SYS_PRCTL_H
 
+/* Define to 1 if you have the <sys/procctl.h> header file. */
+#undef HAVE_SYS_PROCCTL_H
+
 /* Define to 1 if you have the <sys/procset.h> header file. */
 #undef HAVE_SYS_PROCSET_H
 
@@ -1221,9 +1218,6 @@
 /* Define to 1 if the system has the type `u_int32'. */
 #undef HAVE_U_INT32
 
-/* u_int32 type in DNS headers, not others. */
-#undef HAVE_U_INT32_ONLY_WITH_DNS
-
 /* Define to 1 if you have the <values.h> header file. */
 #undef HAVE_VALUES_H
 
@@ -1477,6 +1471,9 @@
 /* Use OpenSSL? */
 #undef OPENSSL
 
+/* Suppress OpenSSL 3 deprecation warnings */
+#undef OPENSSL_SUPPRESS_DEPRECATED
+
 /* Should we open the broadcast socket? */
 #undef OPEN_BCAST_SOCKET
 
@@ -1619,10 +1616,6 @@
 /* Is K_TICK_NAME in nanoseconds? */
 #undef TICK_NANO
 
-/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. This
-   macro is obsolete. */
-#undef TIME_WITH_SYS_TIME
-
 /* Define to 1 if your <sys/time.h> declares `struct tm'. */
 #undef TM_IN_SYS_TIME
 
@@ -1820,15 +1813,8 @@ typedef unsigned int	uintptr_t;
 /* Define to `unsigned int' if <sys/types.h> does not define. */
 #undef size_t
 
-	
-	    #if !defined(_KERNEL) && !defined(PARSESTREAM)
-	    /*
-	     * stdio.h must be included after _GNU_SOURCE is defined
-	     * but before #define snprintf rpl_snprintf
-	     */
-	    # include <stdio.h>	
-	    #endif
-	
+	#include "c99_snprintf.h"
+    
 
 /* Define to rpl_snprintf if the replacement function should be used. */
 #undef snprintf
@@ -1887,3 +1873,15 @@ typedef union mpinfou {
 	# endif
 	#endif	/* !defined(_KERNEL) && !defined(PARSESTREAM) */
 	
+
+
+	/*
+	 * Macro to use in otherwise-empty source files to comply with ANSI C
+	 * requirement that each translation unit (source file) contain some
+	 * declaration.  This has commonly been done by declaring an unused
+	 * global variable of type int or char.  An extern reference to abs()
+	 * serves the same purpose without bloat.  We once used exit() but
+	 * that can produce warnings on systems that declare exit() noreturn.
+	 */
+	#define	NONEMPTY_TRANSLATION_UNIT	extern int abs(int);
+
diff --git a/contrib/ntp/configure.ac b/contrib/ntp/configure.ac
index c2dce35e800d..aef705394309 100644
--- a/contrib/ntp/configure.ac
+++ b/contrib/ntp/configure.ac
@@ -35,7 +35,7 @@ AC_PRESERVE_HELP_ORDER
 # the date YYYYMMDD optionally with -HHMM if there is more than one
 # bump in a day.
 
-ntp_configure_cache_version=20230326
+ntp_configure_cache_version=20240218
 
 # When the cache version of config.cache and configure do not
 # match, NTP_CACHEVERSION will flush the cache.
@@ -55,6 +55,23 @@ AC_DEFINE_UNQUOTED([STR_SYSTEM], ["$host"],
 AC_CONFIG_HEADERS([config.h])
 dnl AC_ARG_PROGRAM
 
+AC_MSG_CHECKING([if we should enable build framework help])
+AC_ARG_ENABLE(
+    [build-framework-help],
+    [AS_HELP_STRING(
+	[--enable-build-framework-help],
+	[+ enable build framework help]
+    )],
+    [ntp_ok=$enableval],
+    [ntp_ok=yes]
+)
+case "$ntp_ok" in
+ yes)
+    ntp_cv_build_framework_help=yes ;;
+ *) ntp_cv_build_framework_help=no ;;
+esac
+AC_MSG_RESULT([$ntp_ok])
+
 ntp_atom_ok=${ntp_atom_ok=no}
 ntp_oncore_ok=${ntp_oncore_ok=no}
 ntp_parse_ok=${ntp_parse_ok=no}
@@ -70,7 +87,7 @@ AX_C99_STRUCT_INIT
 
 NTP_HARDEN([sntp])
 
-NTP_VPATH_HACK		dnl used only by ntpd/Makefile.am
+NTP_VPATH_HACK		dnl used by ntpd/Makefile.am libparse/Makefile.am
 
 NTP_LOCINFO([sntp])	dnl takes over from NTP_BINDIR, in NTP_LIBNTP
 
@@ -78,8 +95,7 @@ AM_PROG_AR
 
 # So far, the only shared library we might use is libopts.
 # It's a small library - we might as well use a static version of it.
-AC_DISABLE_SHARED
-AC_PROG_LIBTOOL
+LT_INIT([disable-shared])
 AC_SUBST([LIBTOOL_DEPS])
 
 # NTP has (so far) been relying on leading-edge autogen, which
@@ -87,7 +103,7 @@ AC_SUBST([LIBTOOL_DEPS])
 # Therefore, by default:
 # - use the version of libopts we ship with
 # - do not install it
-# - build a static copy (AC_DISABLE_SHARED - done earlier)
+# - build a static copy (disable-shared - done earlier)
 case "${enable_local_libopts+set}" in
  set) ;;
  *) enable_local_libopts=yes ;;
@@ -103,29 +119,13 @@ NTP_LIBEVENT_CHECK_NOBUILD([2], [sntp/libevent])
 
 NTP_LIBNTP
 
-AC_MSG_CHECKING([for deprecated --with-arlib])
-AC_ARG_WITH([arlib],
-	AS_HELP_STRING([--with-arlib], [- deprecated, arlib not distributed]),
-	[ans=$withval], [ans=no])
-AC_MSG_RESULT([$ans])
-
-case "$ans" in
- yes)
-    AC_MSG_WARN([Please do not use --with-arlib, arlib is no longer included.  In the future, --with-arlib will not be recognized.])
-    ;;
-esac
-
 dnl  we need to check for cross compile tools for vxWorks here
 AC_PROG_AWK
 AS_UNSET([ac_cv_prog_AWK])
 AC_SUBST([AWK])				dnl scripts/ntpver.in
 AC_PROG_MAKE_SET
 
-AC_SUBST([CFLAGS])
-AC_SUBST([LDFLAGS])
-
 AC_PROG_LN_S
-AC_ISC_POSIX
 
 
 AC_PATH_PROG([PATH_PERL], [perl])
@@ -277,13 +277,13 @@ case "$host" in
  *)
     # HMS: Make sure we check for -lrt for clock_* before this...
     case "$ac_cv_search_clock_gettime" in
-     '') AC_MSG_ERROR([Internal Error: Haven't looked for clock_gettime() yet!]) ;;
+     '') AC_MSG_FAILURE([Internal Error: Haven't looked for clock_gettime() yet!]) ;;
     esac
     AC_SEARCH_LIBS([sched_setscheduler], [rt posix4])
     ;;
 esac
 
-AC_CHECK_HEADERS([bstring.h])
+AC_CHECK_HEADERS([bstring.h sys/procctl.h])
 AC_CHECK_HEADER(
     [dns_sd.h],
     [AC_SEARCH_LIBS(
@@ -3008,23 +3008,7 @@ case "$ntp_libparse" in
 esac
 AC_MSG_RESULT([$ans])
 
-NTP_OPENSSL
-
-AC_MSG_CHECKING([if we want to enable CMAC support])
-case "$ac_cv_header_openssl_cmac_h" in
- yes)
-    AC_DEFINE([ENABLE_CMAC], [1], [Enable CMAC support?])
-    ans="yes"
-    ;;
- *) ans="no"
-    ;;
-esac
-AC_MSG_RESULT([$ans])
-
-NTP_CRYPTO_RAND
-
-# if we are using OpenSSL (--with-crypto), by default Autokey is enabled
-AC_MSG_CHECKING([if we want to include NTP Autokey protocol support])
+# if we have crypto, by default Autokey is enabled
 AC_ARG_ENABLE(
     [autokey],
     AS_HELP_STRING(
@@ -3040,7 +3024,7 @@ case "$ntp_autokey" in
  *)
     case "$ntp_openssl" in
      no)
-	AC_MSG_WARN([Disabling Autokey, --enable-autokey requires --with-crypto.])
+	AC_MSG_WARN([Disabling Autokey, crypto unavailable.])
 	ntp_autokey=no
 	;;
      *)
@@ -3050,6 +3034,7 @@ case "$ntp_autokey" in
     esac
     ;;
 esac
+AC_MSG_CHECKING([if NTP Autokey protocol will be supported])
 AC_MSG_RESULT([$ntp_autokey])
 
 AC_SUBST([MAKE_CHECK_LAYOUT])
@@ -4432,6 +4417,18 @@ AC_DEFINE_UNQUOTED([DYNAMIC_INTERLEAVE], [$ntp_dynamic_interleave],
     [support dynamic interleave?])
 AC_MSG_RESULT([$ntp_ok])
 
+AH_BOTTOM([
+	/*
+	 * Macro to use in otherwise-empty source files to comply with ANSI C
+	 * requirement that each translation unit (source file) contain some
+	 * declaration.  This has commonly been done by declaring an unused
+	 * global variable of type int or char.  An extern reference to abs()
+	 * serves the same purpose without bloat.  We once used exit() but
+	 * that can produce warnings on systems that declare exit() noreturn.
+	 */
+	#define	NONEMPTY_TRANSLATION_UNIT	extern int abs(int);
+])
+
 NTP_UNITYBUILD
 
 NTP_PROBLEM_TESTS
@@ -4455,7 +4452,7 @@ AC_CONFIG_FILES([kernel/sys/Makefile])
 AC_CONFIG_FILES([libntp/Makefile])
 AC_CONFIG_FILES([libparse/Makefile])
 AC_CONFIG_FILES([ntpd/Makefile])
-AC_CONFIG_FILES([ntpd/complete.conf],	[sed -e '/^rlimit$/d' -e '/^$/d' < ntpd/complete.conf > ntpd/complete.conf.new && mv ntpd/complete.conf.new ntpd/complete.conf])
+AC_CONFIG_FILES([ntpd/complete.conf],	[$SED -e '/^rlimit$/d' -e '/^$/d' < ntpd/complete.conf > ntpd/complete.conf.new && mv ntpd/complete.conf.new ntpd/complete.conf])
 AC_CONFIG_FILES([ntpdate/Makefile])
 AC_CONFIG_FILES([ntpdc/Makefile])
 AC_CONFIG_FILES([ntpdc/nl.pl],		[chmod +x ntpdc/nl.pl])
diff --git a/contrib/ntp/flock-build b/contrib/ntp/flock-build
index b537ac349175..14767b934e17 100755
--- a/contrib/ntp/flock-build
+++ b/contrib/ntp/flock-build
@@ -34,23 +34,11 @@ case "$PARALLEL_BUILDS" in
  *)  echo Launching $PARALLEL_BUILDS parallel builds on each machine
 esac
 
-# Backroom:
-#   barnstable	   freebsd-6.1
-#   beauregard	   freebsd-6.0
-# X churchy	   alpha-dec-osf5.1
-#   deacon	   sparc-sun-solaris2.10
-#   grundoon	   freebsd-6.2
-#   howland	   freebsd-6.1
-# o macabre	   freebsd-6.1-STABLE
-# o mort	   freebsd-6.1
-#   whimsy	   sparc-sun-solaris2.10
-
 # Campus:
 # * baldwin	   sparc-sun-solaris2.10
 # * bridgeport	   sparc-sun-solaris2.10
-# * malarky	   sparc-sun-solaris2.10
 # * pogo	   sparc-sun-solaris2.10
-# * rackety	   freebsd-6.1
+# * rackety	   sparc-sun-solaris2.10
 
 if [ ! -r sntp/libevent/build-aux/config.guess ] ; then
 	echo "Error: bootstrap required." 1>&2 && exit 1
@@ -80,8 +68,8 @@ do
 	case "1" in
 	 0)
 	    ssh $i "cd $c_d ; ./build $SIG $PARSE $STD $BUILD_ARGS" &
-	    ssh $i "cd $c_d ; ./build $SIG $PARSE $STD --disable-debugging $BUILD_ARGS" &
-	    ssh $i "cd $c_d ; ./build $SIG $PARSE $STD --without-crypto --enable-c99-snprintf $BUILD_ARGS" &
+	    ssh $i "cd $c_d ; ./build $SIG $PARSE $STD --disable-debugging --disable-saveconfig $BUILD_ARGS" &
+	    ssh $i "cd $c_d ; ./build $SIG $PARSE $STD --without-crypto --enable-c99-snprintf --enable-leap-smear $BUILD_ARGS" &
 	    ssh $i "cd $c_d ; ./build $SIG        $STD --disable-all-clocks --disable-autokey --without-sntp --disable-thread-support $BUILD_ARGS" &
 	    ;;
 	 1)
@@ -103,13 +91,13 @@ do
 
 		case $FB_FIRSTONLY in
 		 '0')
-			./build $SIG $PARSE $STD --disable-debugging $BUILD_ARGS &
+			./build $SIG $PARSE $STD --disable-debugging --disable-saveconfig $BUILD_ARGS &
 
 			COUNT=\`expr \$COUNT + 1\`
 			echo \`date -u '+%H:%M:%S'\` $i started build \$COUNT of 4
 			[ 0 -lt \`expr \$COUNT % $PARALLEL_BUILDS\` ] || wait
 
-			./build $SIG $PARSE $STD --without-crypto --enable-c99-snprintf $BUILD_ARGS &
+			./build $SIG $PARSE $STD --without-crypto --enable-c99-snprintf --enable-leap-smear $BUILD_ARGS &
 
 			COUNT=\`expr \$COUNT + 1\`
 			echo \`date -u '+%H:%M:%S'\` $i started build \$COUNT of 4
diff --git a/contrib/ntp/include/Makefile.am b/contrib/ntp/include/Makefile.am
index dd739ebbcdbd..b661ca639f29 100644
--- a/contrib/ntp/include/Makefile.am
+++ b/contrib/ntp/include/Makefile.am
@@ -8,6 +8,7 @@ noinst_HEADERS =	\
 	ascii.h		\
 	audio.h		\
 	binio.h		\
+	c99_snprintf.h	\
 	declcond.h	\
 	gps.h		\
 	hopf6039.h	\
diff --git a/contrib/ntp/include/c99_snprintf.h b/contrib/ntp/include/c99_snprintf.h
new file mode 100644
index 000000000000..f5c1bf0e117c
--- /dev/null
+++ b/contrib/ntp/include/c99_snprintf.h
@@ -0,0 +1,28 @@
+/*
+ * ntp_c99_snprintf.h
+ *
+ * Included from config.h to deal with replacing [v]snprintf() on older
+ * systems.  The #undef lines below cannot be directly in config.h as
+ * config.status modifies each #undef in config.h.in to either be a
+ * commented-out #undef or a functional #define.  Here they are used
+ * to avoid redefinition warnings on systems such as macos ca. 2024
+ * where system headers define [v]snprintf as preprocessor macros.
+ *
+ * Do not include this file directly, leave it to config.h.
+ */
+
+#if !defined(_KERNEL) && !defined(PARSESTREAM)
+/*
+ * stdio.h must be included in config.h after _GNU_SOURCE is defined
+ * but before #define snprintf rpl_snprintf
+ */
+# include <stdio.h>
+#endif
+
+#ifdef HW_WANT_RPL_SNPRINTF
+# undef snprintf
+#endif
+#ifdef HW_WANT_RPL_VSNPRINTF
+# undef vsnprintf
+#endif
+
diff --git a/contrib/ntp/include/lib_strbuf.h b/contrib/ntp/include/lib_strbuf.h
index 5ee92d6f8341..89da450a5547 100644
--- a/contrib/ntp/include/lib_strbuf.h
+++ b/contrib/ntp/include/lib_strbuf.h
@@ -5,28 +5,28 @@
 #define LIB_STRBUF_H
 
 #include <ntp_types.h>
-#include <ntp_malloc.h>			/* for ZERO() */
+#include <ntp_malloc.h>			/* for zero_mem() */
 
-/*
- * Sizes of things
- */
-#define LIB_NUMBUF	16
 #define	LIB_BUFLENGTH	128
 
-typedef char libbufstr[LIB_BUFLENGTH];
-extern libbufstr lib_stringbuf[LIB_NUMBUF];
-extern int lib_nextbuf;
-extern int lib_inited;
+extern int	lib_inited;
+extern int	ipv4_works;
+extern int	ipv6_works;
 
+extern	void	init_lib(void);
 
 /*
- * Macro to get a pointer to the next buffer
+ * Get a pointer to the next string buffer of LIB_BUFLENGTH octets.
+ * New and modified code should use buf = lib_getbuf() directly to
+ * provide clarity for folks familiar with common C style, but there's
+ * no need to churn the history with a mechanical switch away from
+ * LIB_GETBUF(buf).
  */
-#define	LIB_GETBUF(bufp)					\
-	do {							\
-		ZERO(lib_stringbuf[lib_nextbuf]);		\
-		(bufp) = &lib_stringbuf[lib_nextbuf++][0];	\
-		lib_nextbuf %= COUNTOF(lib_stringbuf);		\
+extern	char* lib_getbuf(void);
+
+#define	LIB_GETBUF(bufp)		\
+	do {				\
+		(bufp) = lib_getbuf();	\
 	} while (FALSE)
 
 #endif	/* LIB_STRBUF_H */
diff --git a/contrib/ntp/include/ntp.h b/contrib/ntp/include/ntp.h
index 258ddd6138f7..7406a79ea8a4 100644
--- a/contrib/ntp/include/ntp.h
+++ b/contrib/ntp/include/ntp.h
@@ -171,8 +171,8 @@ typedef char s_char;
  * Eventually the struct tag will change from interface to endpt_tag.
  * endpt is unrelated to the select algorithm's struct endpoint.
  */
-typedef struct interface endpt;
-struct interface {
+typedef struct endpt_tag endpt;
+struct endpt_tag {
 	endpt *		elink;		/* endpt list link */
 	endpt *		mclink;		/* per-AF_* multicast list */
 	void *		ioreg_ctx;	/* IO registration context */
@@ -185,9 +185,12 @@ struct interface {
 	char		name[32];	/* name of interface */
 	u_short		family;		/* AF_INET/AF_INET6 */
 	u_short		phase;		/* phase in update cycle */
-	u_int32		flags;		/* interface flags */
+	u_int32		flags;		/* INT_ flags */
 	int		last_ttl;	/* last TTL specified */
 	u_int32		addr_refid;	/* IPv4 addr or IPv6 hash */
+#    ifdef WORDS_BIGENDIAN
+	u_int32		old_refid;	/* byte-swapped IPv6 refid */
+#    endif
 	int		num_mcast;	/* mcast addrs enabled */
 	u_long		starttime;	/* current_time at creation */
 	volatile long	received;	/* number of incoming packets */
@@ -200,11 +203,11 @@ struct interface {
 };
 
 /*
- * Flags for interfaces
+ * Flags for network endpoints (interfaces or really addresses)
  */
 #define INT_UP		0x001	/* Interface is up */
 #define	INT_PPP		0x002	/* Point-to-point interface */
-#define	INT_LOOPBACK	0x004	/* the loopback interface */
+#define	INT_LOOPBACK	0x004	/* ::1 or 127.0.0.1 */
 #define	INT_BROADCAST	0x008	/* can broadcast out this interface */
 #define INT_MULTICAST	0x010	/* can multicast out this interface */
 #define	INT_BCASTOPEN	0x020	/* broadcast receive socket is open */
@@ -212,7 +215,8 @@ struct interface {
 #define INT_WILDCARD	0x080	/* wildcard interface - usually skipped */
 #define INT_MCASTIF	0x100	/* bound directly to MCAST address */
 #define INT_PRIVACY	0x200	/* RFC 4941 IPv6 privacy address */
-#define INT_BCASTXMIT	0x400   /* socket setup to allow broadcasts */
+#define INT_BCASTXMIT	0x400	/* socket setup to allow broadcasts */
+#define INT_LL_OF_GLOB	0x800	/* IPv6 link-local duplicate of global */
 
 /*
  * Define flasher bits (tests 1 through 11 in packet procedure)
@@ -342,12 +346,12 @@ struct peer {
 	u_char	status;		/* peer status */
 	u_char	new_status;	/* under-construction status */
 	u_char	reach;		/* reachability register */
+	u_char	filter_nextpt;	/* index into filter shift register */
 	int	flash;		/* protocol error test tally bits */
 	u_long	epoch;		/* reference epoch */
 	int	burst;		/* packets remaining in burst */
 	int	retry;		/* retry counter */
 	int	flip;		/* interleave mode control */
-	int	filter_nextpt;	/* index into filter shift register */
 	double	filter_delay[NTP_SHIFT]; /* delay shift register */
 	double	filter_offset[NTP_SHIFT]; /* offset shift register */
 	double	filter_disp[NTP_SHIFT]; /* dispersion shift register */
@@ -463,11 +467,12 @@ struct peer {
 #define	FLAG_XLEAVE	0x1000	/* interleaved protocol */
 #define	FLAG_XB		0x2000	/* interleaved broadcast */
 #define	FLAG_XBOGUS	0x4000	/* interleaved bogus packet */
-#ifdef	OPENSSL
+#ifdef	AUTOKEY
 # define FLAG_ASSOC	0x8000	/* autokey request */
-#endif /* OPENSSL */
+#endif
 #define FLAG_TSTAMP_PPS	0x10000	/* PPS source provides absolute timestamp */
 #define FLAG_LOOPNONCE	0x20000	/* Use a nonce for the loopback test */
+#define FLAG_DISABLED	0x40000	/* peer is being torn down */
 
 /*
  * Definitions for the clear() routine.  We use memset() to clear
@@ -558,9 +563,15 @@ struct pkt {
 #define	MIN_V4_PKT_LEN	(12 * sizeof(u_int32))	/* min header length */
 #define	LEN_PKT_NOMAC	(12 * sizeof(u_int32))	/* min header length */
 #define	MIN_MAC_LEN	(1 * sizeof(u_int32))	/* crypto_NAK */
-#define	MAX_MD5_LEN	(5 * sizeof(u_int32))	/* MD5 */
-#define	MAX_MAC_LEN	(6 * sizeof(u_int32))	/* SHA */
+#define	MD5_LENGTH	16
+#define	SHAKE128_LENGTH	16
+#define	CMAC_LENGTH	16
+#define	SHA1_LENGTH	20
 #define	KEY_MAC_LEN	sizeof(u_int32)		/* key ID in MAC */
+#define	MAX_MD5_LEN	(KEY_MAC_LEN + MD5_LENGTH)
+#define	MAX_SHAKE128_LEN (KEY_MAC_LEN + SHAKE128_LENGTH)
+#define	MAX_SHA1_LEN	(KEY_MAC_LEN + SHA1_LENGTH)
+#define	MAX_MAC_LEN	(6 * sizeof(u_int32))	/* any MAC */
 #define	MAX_MDG_LEN	(MAX_MAC_LEN-KEY_MAC_LEN) /* max. digest len */
 
 	/*
@@ -703,6 +714,10 @@ struct pkt {
 #define	max(a,b)	(((a) > (b)) ? (a) : (b))
 #define	min3(a,b,c)	min(min((a),(b)), (c))
 
+/* clamp a value within a range */
+#define CLAMP(val, minval, maxval)				\
+			max((minval), min((val), (maxval)))
+
 
 /*
  * Configuration items.  These are for the protocol module (proto_config())
@@ -783,7 +798,7 @@ typedef struct mon_data	mon_entry;
 struct mon_data {
 	mon_entry *	hash_next;	/* next structure in hash list */
 	DECL_DLIST_LINK(mon_entry, mru);/* MRU list link pointers */
-	struct interface * lcladr;	/* address on which this arrived */
+	endpt *		lcladr;	/* address on which this arrived */
 	l_fp		first;		/* first time seen */
 	l_fp		last;		/* last time seen */
 	int		leak;		/* leaky bucket accumulator */
@@ -804,7 +819,7 @@ struct mon_data {
 #define	MDF_POOL	0x08	/* pool client solicitor */
 #define MDF_ACAST	0x10	/* manycast client solicitor */
 #define	MDF_BCLNT	0x20	/* eph. broadcast/multicast client */
-#define MDF_UCLNT	0x40	/* preemptible manycast or pool client */
+#define MDF_PCLNT	0x40	/* preemptible pool client */
 /*
  * In the context of struct peer in ntpd, three of the cast_flags bits
  * represent configured associations which never receive packets, and
@@ -841,11 +856,10 @@ typedef struct restrict_u_tag	restrict_u;
 struct restrict_u_tag {
 	restrict_u *	link;		/* link to next entry */
 	u_int32		count;		/* number of packets matched */
+	u_int32		expire;		/* valid until current_time */
 	u_short		rflags;		/* restrict (accesslist) flags */
-	u_short		mflags;		/* match flags */
-	short		ippeerlimit;	/* IP peer limit */
-	int		srvfuzrftpoll;	/* server response: fuzz reftime */
-	u_long		expire;		/* valid until time */
+	u_int32		mflags;		/* match flags */
+	short		ippeerlimit;	/* limit of associations matching */
 	union {				/* variant starting here */
 		res_addr4 v4;
 		res_addr6 v6;
@@ -856,16 +870,13 @@ struct restrict_u_tag {
 #define	V6_SIZEOF_RESTRICT_U	(offsetof(restrict_u, u)	\
 				 + sizeof(res_addr6))
 
+/* restrictions for (4) a given address */
 typedef struct r4addr_tag	r4addr;
 struct r4addr_tag {
 	u_short		rflags;		/* match flags */
 	short		ippeerlimit;	/* IP peer limit */
 };
 
-char *build_iflags(u_int32 flags);
-char *build_mflags(u_short mflags);
-char *build_rflags(u_short rflags);
-
 /*
  * Restrict (Access) flags (rflags)
  */
@@ -876,10 +887,6 @@ char *build_rflags(u_short rflags);
 #define	RES_NOPEER		0x0010	/* new association denied */
 #define	RES_NOEPEER		0x0020	/* new ephemeral association denied */
 #define RES_LIMITED		0x0040	/* packet rate exceeded */
-#define RES_FLAGS		(RES_IGNORE | RES_DONTSERVE |\
-				    RES_DONTTRUST | RES_VERSION |\
-				    RES_NOPEER | RES_NOEPEER | RES_LIMITED)
-
 #define	RES_NOQUERY		0x0080	/* mode 6/7 packet denied */
 #define	RES_NOMODIFY		0x0100	/* mode 6/7 modify denied */
 #define	RES_NOTRAP		0x0200	/* mode 6/7 set trap denied */
@@ -894,7 +901,10 @@ char *build_rflags(u_short rflags);
 
 #define RES_UNUSED		0x0000	/* Unused flag bits (none left) */
 
-#define	RES_ALLFLAGS		(RES_FLAGS | RES_NOQUERY |	\
+#define	RES_ALLFLAGS		(RES_IGNORE | RES_DONTSERVE |	\
+				 RES_DONTTRUST | RES_VERSION |	\
+				 RES_NOPEER | RES_NOEPEER |	\
+				 RES_LIMITED | RES_NOQUERY |	\
 				 RES_NOMODIFY | RES_NOTRAP |	\
 				 RES_LPTRAP | RES_KOD |		\
 				 RES_MSSNTP | RES_FLAKE |	\
@@ -948,4 +958,15 @@ struct endpoint {
 #define MRU_ROW_LIMIT	256
 /* similar datagrams per response limit for ntpd */
 #define MRU_FRAGS_LIMIT	128
+
+/* found on POSIX systems in sysexit.h */
+#ifndef EX_SOFTWARE
+# define EX_SOFTWARE	70	/* internal software error */
+#endif
+
+#define BYTESWAP32(u32)							\
+			(((u_int32)(u32) & 0xff000000) >> 24 |		\
+			 ((u_int32)(u32) &   0xff0000) >>  8 |		\
+			 ((u_int32)(u32) &     0xff00) <<  8 |		\
+			 ((u_int32)(u32) &       0xff) << 24)
 #endif /* NTP_H */
diff --git a/contrib/ntp/include/ntp_config.h b/contrib/ntp/include/ntp_config.h
index dbb64e3a2eee..2fce70945035 100644
--- a/contrib/ntp/include/ntp_config.h
+++ b/contrib/ntp/include/ntp_config.h
@@ -113,7 +113,9 @@ struct restrict_node_tag {
 	address_node *	addr;
 	address_node *	mask;
 	attr_val_fifo *	flag_tok_fifo;
+	int/*BOOL*/	remove;
 	int		line_no;
+	int		column;
 	short		ippeerlimit;
 	short		srvfuzrft;
 };
@@ -317,10 +319,13 @@ void	  destroy_attr_val(attr_val *node);
 filegen_node *create_filegen_node(int filegen_token,
 				  attr_val_fifo *options);
 string_node *create_string_node(char *str);
-restrict_node *create_restrict_node(address_node *addr,
-				    address_node *mask,
-				    short ippeerlimit,
-				    attr_val_fifo *flags, int line_no);
+restrict_node *create_restrict_node(address_node *	addr,
+				    address_node *	mask,
+				    short		ippeerlimit,
+				    attr_val_fifo *	flag_tok_fifo,
+				    int/*BOOL*/		remove,
+				    int			nline,
+				    int			ncol);
 int_node *create_int_node(int val);
 addr_opts_node *create_addr_opts_node(address_node *addr,
 				      attr_val_fifo *options);
diff --git a/contrib/ntp/include/ntp_control.h b/contrib/ntp/include/ntp_control.h
index 2fe0f30bbd78..91b85aa52df4 100644
--- a/contrib/ntp/include/ntp_control.h
+++ b/contrib/ntp/include/ntp_control.h
@@ -159,7 +159,7 @@ struct ntp_control {
  */
 struct ctl_trap {
 	sockaddr_u tr_addr;		/* address of trap recipient */
-	struct interface *tr_localaddr;	/* interface to send this through */
+	endpt *tr_localaddr;		/* interface to send this through */
 	u_long tr_settime;		/* time trap was set */
 	u_long tr_count;		/* async messages sent to this guy */
 	u_long tr_origtime;		/* time trap was originally set */
diff --git a/contrib/ntp/include/ntp_lists.h b/contrib/ntp/include/ntp_lists.h
index d741974943ef..bed692ff294e 100644
--- a/contrib/ntp/include/ntp_lists.h
+++ b/contrib/ntp/include/ntp_lists.h
@@ -181,7 +181,7 @@ do {								\
 
 #define UNLINK_EXPR_SLIST(punlinked, listhead, expr, nextlink,	\
 			  entrytype)				\
-do {								\
+if (NULL != (listhead)) {					\
 	entrytype **ppentry;					\
 								\
 	ppentry = &(listhead);					\
@@ -202,6 +202,8 @@ do {								\
 	} else {						\
 		(punlinked) = NULL;				\
 	}							\
+} else do {							\
+	(punlinked) = NULL;					\
 } while (FALSE)
 
 #define UNLINK_SLIST(punlinked, listhead, ptounlink, nextlink,	\
diff --git a/contrib/ntp/include/ntp_md5.h b/contrib/ntp/include/ntp_md5.h
index 8b5a7d0cbb49..22caff350cd9 100644
--- a/contrib/ntp/include/ntp_md5.h
+++ b/contrib/ntp/include/ntp_md5.h
@@ -6,6 +6,18 @@
 #ifndef NTP_MD5_H
 #define NTP_MD5_H
 
+/* Use the system MD5 or fall back on libisc's */
+# if defined HAVE_MD5_H && defined HAVE_MD5INIT
+#  include <md5.h>
+# else
+#  include "isc/md5.h"
+   typedef isc_md5_t		MD5_CTX;
+#  define MD5_DIGEST_LENGTH	ISC_MD5_DIGESTLENGTH
+#  define MD5Init(c)		isc_md5_init(c)
+#  define MD5Update(c, p, s)	isc_md5_update(c, (const void *)p, s)
+#  define MD5Final(d, c)	isc_md5_final((c), (d))	/* swapped */
+# endif
+
 # define KEY_TYPE_MD5			NID_md5
 
 #ifdef OPENSSL
@@ -20,20 +32,11 @@
 /*
  * Provide OpenSSL-alike MD5 API if we're not using OpenSSL
  */
-# if defined HAVE_MD5_H && defined HAVE_MD5INIT
-#  include <md5.h>
-# else
-#  include "isc/md5.h"
-   typedef isc_md5_t		MD5_CTX;
-#  define MD5Init(c)		isc_md5_init(c)
-#  define MD5Update(c, p, s)	isc_md5_update(c, p, s)
-#  define MD5Final(d, c)	isc_md5_final((c), (d))	/* swapped */
-# endif
 
   typedef MD5_CTX			EVP_MD_CTX;
 
 # define NID_md5			4	/* from openssl/objects.h */
-# define EVP_MAX_MD_SIZE		64	/* from openssl/evp.h */
+# define EVP_MAX_MD_SIZE		MD5_DIGEST_LENGTH
 # define EVP_MD_CTX_free(c)		free(c)
 # define EVP_MD_CTX_new()		calloc(1, sizeof(MD5_CTX))
 # define EVP_get_digestbynid(t)		NULL
@@ -47,7 +50,7 @@
 # define EVP_DigestFinal(c, d, pdl)	\
 	do {				\
 		MD5Final((d), (c));	\
-		*(pdl) = 16;		\
+		*(pdl) = MD5_LENGTH;	\
 	} while (0)
 # endif	/* !OPENSSL */
 #endif	/* NTP_MD5_H */
diff --git a/contrib/ntp/include/ntp_net.h b/contrib/ntp/include/ntp_net.h
index 0577402bfb2c..09cc7f65f97b 100644
--- a/contrib/ntp/include/ntp_net.h
+++ b/contrib/ntp/include/ntp_net.h
@@ -195,7 +195,7 @@ typedef union {
 #define SOCK_UNSPEC_S(psau)					\
 	(SOCK_UNSPEC(psau) && !SCOPE(psau))
 
-/* choose a default net interface (struct interface) for v4 or v6 */
+/* choose a default net interface (endpt) for v4 or v6 */
 #define ANY_INTERFACE_BYFAM(family)				\
 	((AF_INET == family)					\
 	     ? any_interface					\
@@ -227,6 +227,12 @@ typedef union {
  */
 #define	LOOPBACKADR	0x7f000001
 #define	LOOPNETMASK	0xff000000
+#ifdef WORDS_BIGENDIAN
+# define LOOPBACKADR_N	LOOPBACKADR
+#else 
+# define LOOPBACKADR_N	0x0100007f
+#endif
+
 
 #define	ISBADADR(srcadr)					\
 	(IS_IPV4(srcadr)					\
@@ -234,5 +240,10 @@ typedef union {
 	     == (LOOPBACKADR & LOOPNETMASK))			\
 	 && SRCADR(srcadr) != LOOPBACKADR)
 
+#define IS_LOOPBACK_ADDR(psau)					\
+		(IS_IPV4(psau)					\
+		    ? LOOPBACKADR == SRCADR(psau)		\
+		    : IN6_IS_ADDR_LOOPBACK(PSOCK_ADDR6(psau))	\
+		)
 
 #endif /* NTP_NET_H */
diff --git a/contrib/ntp/include/ntp_psl.h b/contrib/ntp/include/ntp_psl.h
index a0c2662d44c7..c3a6846f90d0 100644
--- a/contrib/ntp/include/ntp_psl.h
+++ b/contrib/ntp/include/ntp_psl.h
@@ -4,12 +4,15 @@
 
 /*
  * Poll Skew List Item
+ * u_in32 is large enough for sub and qty so long as NTP_MAXPOLL < 31
  */
-
+#if NTP_MAXPOLL >= 31
+#include "psl_item structure needs larger type"
+#endif
 typedef struct psl_item_tag {
-	int		sub;	/* int or short?  unsigned is OK, but why? */
-	int		qty;	/* int or short?  unsigned is OK, but why? */
-	int		msk;	/* int or short?  unsigned is OK */
+	u_int32	sub;
+	u_int32	qty;
+	u_int32	msk;
 } psl_item;
 
 int get_pollskew(int, psl_item *);
